# $Id: Example.pm,v 1.7.2.1 2002/04/30 14:21:33 bengen Exp $

#
# Example code for virus scanners
#

package AMAVIS::AV::Example;
use strict;

use vars qw($VERSION);
$VERSION='0.1';

use AMAVIS;
use AMAVIS::Logging;

use vars qw(
	    $cfg_example_binary
	   );

sub init {
  my $self = shift;
  my $args = shift;
  push @{$$args{'virus_scanners'}}, 'Example';
  $cfg_example_binary = $AMAVIS::cfg->val('Exemple', 'example');
  if ($cfg_example_binary eq '') {
    writelog($args,LOG_CRIT, "Path to Example not specified");
    return 0;
  }
  if (! -x $cfg_example_binary) {
    writelog($args,LOG_CRIT, "Example ($cfg_example_binary) not executable");
    return 0;
  }
  writelog($args,LOG_DEBUG,__PACKAGE__." initialized.\n");
  # Return successfully
  return 1;
}

# Called from AMAVIS.pm. Scanning takes place here.
sub scan {
  my $self = shift;
  my $args = shift;

  my @output;

  writelog($args,LOG_DEBUG,"Scanning with Example");
  writelog($args,LOG_DEBUG,
	   "Output from $cfg_example_binary --dumb $$args{directory}/parts");
  my $output_handle = cmd_pipe($args, $cfg_example_binary, 
			       '--dumb', 
			       "$$args{directory}/parts");
  while(<$output_handle>) {
    chomp;
    s/[\000-\037]*//g;
    writelog($args,LOG_DEBUG,$_);
    push @output, $_;
  }
  writelog($args,LOG_DEBUG, "End output from $cfg_example_binary\n");
  wait;
  my $errval = ($? >> 8);
  writelog($args,LOG_DEBUG,"Return code $errval");
  if ($errval != 0) {
  }

  # Scanning happens here

#   if ($error) {
#     writelog($args,LOG_ERR,
# 	     "Virus scanner failure: Some reason.");
#     # return ERROR
#     return 0;
#   }

#   if ($virus_found) {
#     push @{$$args{'found_viruses'}{'Example'}}, 'virus name';
#   }

  # Return successfully...
  return 1;
}

1;
