# $Id: Admin.pm,v 1.15.2.2 2002/05/07 00:56:03 bengen Exp $

package AMAVIS::Notify::Admin;
use strict;
use vars qw($VERSION);
$VERSION='0.1';

use AMAVIS;
use AMAVIS::Logging;

use vars qw(
	    $cfg_sender
	    $cfg_admin
	   );

sub init {
  my $self = shift;
  my $args = shift;
  writelog($args,LOG_DEBUG,__PACKAGE__." initialized.");
  $cfg_sender = $AMAVIS::cfg->val('Notify', 'mail from');
  $cfg_sender = 'postmaster' unless defined($cfg_sender);
  $cfg_admin = $AMAVIS::cfg->val('Notify', 'admin');
  $cfg_admin = 'postmaster' unless defined($cfg_admin);
  # Return successfully
  return 1;
}

sub notify {
  my $self = shift;
  my $args = shift;
  # FIXME
  my $recipient = $cfg_admin;

  if ($recipient eq '<>') {
    writelog($args,LOG_DEBUG, __PACKAGE__.
	     ': Not warning admin: empty address.');
    return 1;
  }

  my $orig_sender = $$args{'sender'};
  if ($orig_sender eq '') {
    $orig_sender = '(empty address)';
  }

  writelog($args,LOG_DEBUG, __PACKAGE__.
	   ': Warning admin: '.$recipient.'.');

  my $message = <<"EOF";
From: $cfg_sender
To: $recipient
Subject: FOUND VIRUS IN MAIL FROM $orig_sender.

The virus checker has found potentially malicious code in a mail by
$orig_sender. Delivery has been stopped.

The recipient(s) for this message were:

EOF

  $message.=join "\n",@{$$args{'recipients'}};

  if (defined $$args{'quarantine_file'}) {
    $message.= << "EOF";


The message has been quarantined as
$$args{'quarantine_file'}.msg.

The corresponding logfile has been written to
$$args{'quarantine_file'}.log.
EOF
  };
  foreach my $scanner (@{$$args{'virus_scanners'}}) {
    $message.="\n$scanner found:\n";
    foreach my $virus (@{$$args{'found_viruses'}{$scanner}}) {
      $message.=" $virus\n";
    }
  }
  
  $message.="\n".('-'x 72)."\nMessage headers follow:\n";
  $message.=$$args{'headers'};
  
  $AMAVIS::mta->send_message($args, $message, '<>', $recipient)
    or writelog($args,LOG_ERR,"Error notifying admin $recipient");

  return 1;
}

1;
